-- =============================================================================
-- Sistema    : Comercial Comissaria
-- Programador: Jos Sant`Anna e Leonardo Monteiro
-- Data       : ??/08/2002
-- Descrio  : Rotina para calcular os nutrientes das receitas.
-- =============================================================================
-- @C:\WIN_V2\SQL\End_Conv\ORACLE\1120_COCSTP_CALC_NUTRI_REC.SQL
-- EXECUTE CALC_NUTRI_REC('0000000009','0001','','P','0000001175','P','0000001175')
--DBMS_OUTPUT.PUT_LINE('1');
--raise_application_error(-20504,P_NRSEQNUTREC||' '||P_CDFILIAL||' '||P_CDCIA||' '||P_CDFILRPRI||' '||P_CDRECEPRI||' '||V_CDFILIREC||' '||V_CDRECEITA, True);
-- =============================================================================
-- @C:\WIN_V4\SQL\End_Conv\ORACLE\1120_COCSTPO.SQL
-- =============================================================================
CREATE OR REPLACE PROCEDURE CALC_NUTRI_REC(
P_NRSEQNUTREC  IN TRABNUTRIREC.NRSEQNUTREC%TYPE,
P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
P_CDCIA        IN COMPANHIA.CDCIA%TYPE,
P_CDRECEPRI    IN RECEITA.CDRECEITA%TYPE,
P_CDRECEITA    IN RECEITA.CDRECEITA%TYPE
) AS
V_IDTIPORECNUT TRABNUTRIREC.IDTIPORECNUT%TYPE;
V_QTRENDREC    RENDPADRAO  .QTRENDRECPAD%TYPE;
V_QTAPROREC    RENDPADRAO  .QTAPRORECPAD%TYPE;

V_CDRECEITA    RECEITA.CDRECEITA%TYPE;
V_QTRENDSUBREC SUBRECEITA.QTRENDSUBREC%TYPE;

V_PROREC       VARCHAR2(12);
V_QTPROREC     VARCHAR2(12);

V_SUBREC       VARCHAR2(12);
V_QTSUBREC     VARCHAR2(12);
V_CDFISREC     VARCHAR2(13);
V_CDSUBREC     VARCHAR2(12);

V_INSERT_TEXT  VARCHAR2(3500);
C_INSERT       INTEGER;
V_RESULT       INTEGER;

CURSOR C_SUBREC1 IS
SELECT CDSUBREC,QTRENDSUBREC
FROM SUBRECEITA
WHERE (CDRECEITA = P_CDRECEITA);

CURSOR C_SUBREC2 IS
SELECT CDSUBRECLOC,QTRENDSUBLOC
FROM SUBRECLOC
WHERE (CDFILIAL  = P_CDFILIAL ) AND
      (CDRECEITA = P_CDRECEITA);

BEGIN

   RETORNA_RENDREC(P_CDFILIAL,P_CDRECEITA,V_IDTIPORECNUT,
                   V_QTRENDREC,V_QTAPROREC);

   IF V_IDTIPORECNUT IS NOT NULL THEN

   	IF V_QTRENDREC = 0 THEN
         raise_application_error(-20502, 'A receita "'||P_CDRECEITA||'" possui rendimento zero.', True);
      END IF;

      IF V_IDTIPORECNUT = '1' THEN
         OPEN C_SUBREC1;
      ELSIF V_IDTIPORECNUT = '2' THEN
         OPEN C_SUBREC2;
      END IF;

      LOOP
         IF V_IDTIPORECNUT = '1' THEN
            FETCH C_SUBREC1
            INTO
            V_CDRECEITA,V_QTRENDSUBREC;
            EXIT WHEN C_SUBREC1%NOTFOUND;
         ELSIF V_IDTIPORECNUT = '2' THEN
            FETCH C_SUBREC2
            INTO
            V_CDRECEITA,V_QTRENDSUBREC;
            EXIT WHEN C_SUBREC2%NOTFOUND;
         END IF;

         CALC_NUTRI_REC(P_NRSEQNUTREC,P_CDFILIAL,P_CDCIA,P_CDRECEPRI,V_CDRECEITA);

      END LOOP;
      IF V_IDTIPORECNUT = '1' THEN
         CLOSE C_SUBREC1;
         V_PROREC   := 'PRORECEITA';
         V_QTPROREC := 'QTPRODREC';
         V_SUBREC   := 'SUBRECEITA';
         V_QTSUBREC := 'QTRENDSUBREC';
         V_CDFISREC := 'CDFILISUBREC';
         V_CDSUBREC := 'CDSUBREC';
      ELSIF V_IDTIPORECNUT = '2' THEN
         CLOSE C_SUBREC2;
         V_PROREC   := 'PRORECLOC';
         V_QTPROREC := 'QTPRODLOC';
         V_SUBREC   := 'SUBRECLOC';
         V_QTSUBREC := 'QTRENDSUBLOC';
         V_CDFISREC := 'CDFILISUBRECL';
         V_CDSUBREC := 'CDSUBRECLOC';
      END IF;

      V_INSERT_TEXT    := '';
      V_INSERT_TEXT    := V_INSERT_TEXT ||' INSERT INTO TRABNUTRIREC ';
      V_INSERT_TEXT    := V_INSERT_TEXT ||' (NRSEQNUTREC,CDFILIAL,CDCIA,';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'  CDRECEITA,IDTIPORECNUT,CDNUTRIENTE,QTNUTRIRECE)';
      V_INSERT_TEXT    := V_INSERT_TEXT ||' SELECT :P_NRSEQNUTREC,:P_CDFILIAL,:P_CDCIA,';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'        :P_CDRECEITA,:V_IDTIPORECNUT,NU.CDNUTRIENTE,';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'        0';
      V_INSERT_TEXT    := V_INSERT_TEXT ||' FROM (SELECT NP.CDNUTRIENTE';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'       FROM NUTRPROD NP, '||V_PROREC||' PR, PRODFILI PF, PRODUTO PD';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'       WHERE (PR.CDRECEITA    = :P_CDRECEITA) AND';
      IF V_IDTIPORECNUT IN ('2','4') THEN
         V_INSERT_TEXT := V_INSERT_TEXT ||'             (PR.CDFILIAL     = :P_CDFILIAL ) AND';
      END IF;
      IF V_IDTIPORECNUT IN ('3','4') THEN
         V_INSERT_TEXT := V_INSERT_TEXT ||'             (PR.CDCIA        = :P_CDCIA    ) AND';
      END IF;
      V_INSERT_TEXT    := V_INSERT_TEXT ||'             (NP.CDPRODUTO    = PR.CDPRODUTO) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'             (PF.CDFILIAL (+) = :P_CDFILIAL ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'             (PF.CDPRODUTO(+) = PR.CDPRODUTO) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'             (PR.CDPRODUTO    = PD.CDPRODUTO)';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'      UNION';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'       SELECT NR.CDNUTRIENTE';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'       FROM '||V_SUBREC||' SR, TRABNUTRIREC NR';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'       WHERE (SR.CDRECEITA   = :P_CDRECEITA       ) AND';
      IF V_IDTIPORECNUT IN ('2','4') THEN
         V_INSERT_TEXT := V_INSERT_TEXT ||'             (SR.CDFILIAL    = :P_CDFILIAL        ) AND';
      END IF;
      IF V_IDTIPORECNUT IN ('3','4') THEN
         V_INSERT_TEXT := V_INSERT_TEXT ||'             (SR.CDCIA       = :P_CDCIA           ) AND';
      END IF;
      V_INSERT_TEXT    := V_INSERT_TEXT ||'             (NR.NRSEQNUTREC = :P_NRSEQNUTREC     ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'             (NR.CDFILIAL    = :P_CDFILIAL        ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'             (NR.CDRECEITA   = SR.'||V_CDSUBREC||')';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'      MINUS';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'       SELECT CDNUTRIENTE';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'       FROM TRABNUTRIREC';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'       WHERE (NRSEQNUTREC = :P_NRSEQNUTREC) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'             (CDRECEITA   = :P_CDRECEITA  )) NU';
      V_INSERT_TEXT    := V_INSERT_TEXT ||' GROUP BY NU.CDNUTRIENTE';

      C_INSERT := DBMS_SQL.OPEN_CURSOR;

      DBMS_SQL.PARSE(C_INSERT, V_INSERT_TEXT, DBMS_SQL.V7);
      DBMS_SQL.BIND_VARIABLE(C_INSERT, ':P_NRSEQNUTREC' , P_NRSEQNUTREC );
      DBMS_SQL.BIND_VARIABLE(C_INSERT, ':P_CDFILIAL'    , P_CDFILIAL    );
      DBMS_SQL.BIND_VARIABLE(C_INSERT, ':P_CDCIA'       , P_CDCIA       );
      --DBMS_SQL.BIND_VARIABLE(C_INSERT, ':P_CDFILRPRI'   , P_CDFILRPRI   );
      --DBMS_SQL.BIND_VARIABLE(C_INSERT, ':P_CDRECEPRI'   , P_CDRECEPRI   );
      DBMS_SQL.BIND_VARIABLE(C_INSERT, ':P_CDRECEITA'   , P_CDRECEITA   );
      DBMS_SQL.BIND_VARIABLE(C_INSERT, ':V_IDTIPORECNUT', V_IDTIPORECNUT);

      V_RESULT := DBMS_SQL.EXECUTE(C_INSERT);

      DBMS_SQL.CLOSE_CURSOR(C_INSERT);

      V_INSERT_TEXT    := '';
      V_INSERT_TEXT    := V_INSERT_TEXT ||' UPDATE TRABNUTRIREC NR';
      V_INSERT_TEXT    := V_INSERT_TEXT ||' SET QTNUTRIRECE = (SELECT SUM(QTNUTRI) / :V_QTRENDREC';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                    FROM (SELECT NP.CDNUTRIENTE,NVL(PR.'||V_QTPROREC||'* NP.QTNUTRPROD * 10 * DECODE(NVL(VRPESOUNIDFI, 0), 0, PD.VRPESOUNID, PF.VRPESOUNIDFI), 0) QTNUTRI';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                          FROM NUTRPROD NP,'||V_PROREC||' PR, PRODFILI PF, PRODUTO PD';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                          WHERE'; --(NP.CDNUTRIENTE  = NR.CDNUTRIENTE) AND';
      IF V_IDTIPORECNUT IN ('2','4') THEN
         V_INSERT_TEXT := V_INSERT_TEXT ||'                                (PR.CDFILIAL     = :P_CDFILIAL   ) AND';
      END IF;
      IF V_IDTIPORECNUT IN ('3','4') THEN
         V_INSERT_TEXT := V_INSERT_TEXT ||'                                (PR.CDCIA        = :P_CDCIA      ) AND';
      END IF;
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                                (PR.CDRECEITA    = :P_CDRECEITA  ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                                (NP.CDPRODUTO    = PR.CDPRODUTO  ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                                (PF.CDFILIAL (+) = :P_CDFILIAL   ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                                (PF.CDPRODUTO(+) = PR.CDPRODUTO  ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                                (PR.CDPRODUTO    = PD.CDPRODUTO  )';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                         UNION ALL';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                          SELECT TN.CDNUTRIENTE,NVL(SR.'||V_QTSUBREC||'*TN.QTNUTRIRECE, 0) QTNUTRI';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                          FROM '||V_SUBREC||' SR, TRABNUTRIREC TN';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                          WHERE (SR.CDRECEITA   = :P_CDRECEITA       ) AND';
      IF V_IDTIPORECNUT IN ('2','4') THEN
         V_INSERT_TEXT := V_INSERT_TEXT ||'                                (SR.CDFILIAL    = :P_CDFILIAL        ) AND';
      END IF;
      IF V_IDTIPORECNUT IN ('3','4') THEN
         V_INSERT_TEXT := V_INSERT_TEXT ||'                                (SR.CDCIA       = :P_CDCIA           ) AND';
      END IF;
--      V_INSERT_TEXT    := V_INSERT_TEXT ||'                                --(TN.CDNUTRIENTE = NR.CDNUTRIENTE     ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                                (TN.NRSEQNUTREC = :P_NRSEQNUTREC     ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                                (TN.CDFILIAL    = :P_CDFILIAL        ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                                (TN.CDRECEITA   = SR.'||V_CDSUBREC||')) NP';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                    WHERE (NP.CDNUTRIENTE  = NR.CDNUTRIENTE))';
      V_INSERT_TEXT    := V_INSERT_TEXT ||' WHERE (NR.NRSEQNUTREC = :P_NRSEQNUTREC) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'       (NR.CDFILIAL    = :P_CDFILIAL   ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'       (NR.CDCIA||''-''= :P_CDCIA ||''-'') AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'       (NR.CDRECEITA   = :P_CDRECEITA  ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'       (EXISTS (SELECT NP.CDNUTRIENTE';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                FROM NUTRPROD NP,'||V_PROREC||' PR, PRODFILI PF, PRODUTO PD';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                WHERE (NP.CDNUTRIENTE   = NR.CDNUTRIENTE) AND';
      IF V_IDTIPORECNUT IN ('2','4') THEN
         V_INSERT_TEXT := V_INSERT_TEXT ||'                      (PR.CDFILIAL      = :P_CDFILIAL   ) AND';
      END IF;
      IF V_IDTIPORECNUT IN ('3','4') THEN
         V_INSERT_TEXT := V_INSERT_TEXT ||'                      (PR.CDCIA         = :P_CDCIA      ) AND';
      END IF;
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                      (PR.CDRECEITA     = :P_CDRECEITA  ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                      (NP.CDPRODUTO     = PR.CDPRODUTO  ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                      (PF.CDFILIAL(+)   = :P_CDFILIAL   ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                      (PF.CDPRODUTO(+)  = PR.CDPRODUTO  ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                      (PR.CDPRODUTO     = PD.CDPRODUTO  )';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'               UNION';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                SELECT TN.CDNUTRIENTE';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                FROM '||V_SUBREC||' SR, TRABNUTRIREC TN';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                WHERE (SR.CDRECEITA   = :P_CDRECEITA       ) AND';
      IF V_IDTIPORECNUT IN ('2','4') THEN
         V_INSERT_TEXT := V_INSERT_TEXT ||'                      (SR.CDFILIAL    = :P_CDFILIAL        ) AND';
      END IF;
      IF V_IDTIPORECNUT IN ('3','4') THEN
         V_INSERT_TEXT := V_INSERT_TEXT ||'                      (SR.CDCIA       = :P_CDCIA           ) AND';
      END IF;
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                      (TN.CDNUTRIENTE = NR.CDNUTRIENTE     ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                      (TN.NRSEQNUTREC = :P_NRSEQNUTREC     ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                      (TN.CDFILIAL    = :P_CDFILIAL        ) AND';
      V_INSERT_TEXT    := V_INSERT_TEXT ||'                      (TN.CDRECEITA   = SR.'||V_CDSUBREC||')))';

      C_INSERT := DBMS_SQL.OPEN_CURSOR;
      DBMS_SQL.PARSE(C_INSERT, V_INSERT_TEXT, DBMS_SQL.V7);

      DBMS_SQL.BIND_VARIABLE(C_INSERT, ':P_NRSEQNUTREC' , P_NRSEQNUTREC );
      DBMS_SQL.BIND_VARIABLE(C_INSERT, ':P_CDFILIAL'    , P_CDFILIAL    );
      DBMS_SQL.BIND_VARIABLE(C_INSERT, ':P_CDCIA'       , P_CDCIA       );
      --DBMS_SQL.BIND_VARIABLE(C_INSERT, ':P_CDFILRPRI'   , P_CDFILRPRI   );
      --DBMS_SQL.BIND_VARIABLE(C_INSERT, ':P_CDRECEPRI'   , P_CDRECEPRI   );
      DBMS_SQL.BIND_VARIABLE(C_INSERT, ':P_CDRECEITA'   , P_CDRECEITA   );
      DBMS_SQL.BIND_VARIABLE(C_INSERT, ':V_QTRENDREC'   , V_QTRENDREC   );

		V_RESULT := DBMS_SQL.EXECUTE(C_INSERT);
		DBMS_SQL.CLOSE_CURSOR(C_INSERT);

   END IF;
END;
/
